SAXClassAdapter (ASM 5.0.4 Documentation)
Date: 2015-09-18

org.objectweb.asm.xml

## Class SAXClassAdapter

- java.lang.Object
- - org.objectweb.asm.ClassVisitor
  - - org.objectweb.asm.xml.SAXClassAdapter

-     public final class SAXClassAdapter
      extends ClassVisitor

  A `ClassVisitor` that generates SAX 2.0 events from the visited class. It can feed any kind of `ContentHandler`, e.g. XML serializer, XSLT or XQuery engines.
  Author:
    Eugene Kuleshov
  See Also:
    `Processor`, `ASMContentHandler`

- - ### Field Summary

    - ### Fields inherited from class org.objectweb.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SAXClassAdapter(ContentHandler h, boolean singleDocument)` Constructs a new `SAXClassAdapter` object.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Visits the enclosing class of the class.
    `void` | `visitSource(String source, String debug)` Visits the source of the class.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the class signature.

    - ### Methods inherited from class org.objectweb.asm.ClassVisitor

      `visitAttribute`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SAXClassAdapter

          public SAXClassAdapter(ContentHandler h,
                         boolean singleDocument)

      Constructs a new `SAXClassAdapter` object.
      Parameters:
        `h` - content handler that will be used to send SAX 2.0 events.
        `singleDocument` - if `true` adapter will not produce `startDocument()` and `endDocument()` events.

  - ### Method Detail

    - #### visitSource

          public void visitSource(String source,
                         String debug)

      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `source` - the name of the source file from which the class was compiled. May be `null`.
        `debug` - additional debug information to compute the correspondance between source and compiled elements of the class. May be `null`.

    - #### visitOuterClass

          public void visitOuterClass(String owner,
                             String name,
                             String desc)

      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class.
        `name` - the name of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.
        `desc` - the descriptor of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                          boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Overrides:
        `visitAnnotation` in class `ClassVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                              TypePath typePath,
                                              String desc,
                                              boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation on a type in the class signature.
      Overrides:
        `visitTypeAnnotation` in class `ClassVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `CLASS_TYPE_PARAMETER`, `CLASS_TYPE_PARAMETER_BOUND` or `CLASS_EXTENDS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visit

          public void visit(int version,
                   int access,
                   String name,
                   String signature,
                   String superName,
                   String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitField

          public FieldVisitor visitField(int access,
                                String name,
                                String desc,
                                String signature,
                                Object value)

      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be `null` if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or `null` if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                  String name,
                                  String desc,
                                  String signature,
                                  String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Overrides:
        `visitMethod` in class `ClassVisitor`
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitInnerClass

          public final void visitInnerClass(String name,
                             String outerName,
                             String innerName,
                             int access)

      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of an inner class (see `getInternalName`).
        `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null` for not member classes.
        `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
        `access` - the access flags of the inner class as originally declared in the enclosing class.

    - #### visitEnd

          public final void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`